var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import Debug from 'debug';
import { join, basename, dirname } from 'path';
const debug = Debug('plugins/tutorials/utils');
const top = dirname(require.resolve('@kui-shell/plugin-tutorials/package.json'));
export const contentDir = join(top, 'samples/@tutorials');
export const projectHome = projectName => join(contentDir, projectName);
const readJSON = (projectHome, fileName) => new Promise((resolve, reject) => {
    debug('readJSON');
    try {
        if (projectHome.indexOf('@tutorials') >= 0) {
            const projectName = basename(projectHome);
            debug('reading built-in', projectName, fileName);
            resolve(require('@kui-shell/plugin-tutorials/samples/@tutorials/' + projectName + '/' + fileName));
        }
        else {
            debug('reading external', projectHome, fileName);
            resolve(join(projectHome, fileName));
        }
    }
    catch (err) {
        reject(err);
    }
});
export const readProject = (projectHome) => __awaiter(void 0, void 0, void 0, function* () {
    debug('readProject', projectHome);
    if (basename(projectHome) === 'package.json') {
        return readProject(dirname(projectHome));
    }
    return Promise.all([readJSON(projectHome, 'package.json'), readJSON(projectHome, 'tutorial.json')]).then(([config, tutorial]) => {
        return {
            config: Object.assign({}, { projectName: config.name }, config),
            tutorial,
            projectHome
        };
    });
});
//# sourceMappingURL=util.js.map